/*
 * Created on 20.04.2005
 *
 */
package org.eclipse.contribution.junit;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.ui.dialogs.PropertyPage;

/**
 * @author Andreas
 *
 */
public class AutoTestPropertyPage extends PropertyPage{

	Button autoTest;
	
	
	/**
	 * 
	 */
	public AutoTestPropertyPage() {
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.preference.PreferencePage#createContents(org.eclipse.swt.widgets.Composite)
	 */
	protected Control createContents(Composite parent) {
		noDefaultAndApplyButton();
		Control composite = addControl(parent);
		try {
			boolean hasNature = getProject().hasNature(
					JUnitPlugin.AUTO_TEST_NATURE);
			autoTest.setSelection(hasNature);
		} catch (CoreException e) {
		} catch (Exception e){
			System.out.println("EXCEPTION: "+e);
		}
		return composite;
	}
	
	/**
	 * @return
	 */
	
	private IProject getProject() {
		return (IProject) getElement();
	}
	
	/**
	 * @param parent
	 * @return
	 */
	private Control addControl(Composite parent) {
		Composite composite = new Composite(parent, SWT.NULL);
		GridLayout layout = new GridLayout();
		layout.numColumns=1;
		composite.setLayout(layout);
		GridData data = new GridData();
		data.verticalAlignment = GridData.FILL;
		data.horizontalAlignment = GridData.FILL;
		composite.setLayoutData(data);
		
		Font font = parent.getFont();
		Label label = new Label(composite, SWT.NONE);
		label.setText("When auto-testing, after every build all Tests will be run.");
		label.setFont(font);
		autoTest = new Button(composite, SWT.CHECK);
		autoTest.setText("Auto-test");
		autoTest.setFont(font);
		return composite;
	}
	
	public boolean performOk(){
		try {
			JUnitPlugin plugin = JUnitPlugin.getPlugin();
			if (autoTest.getSelection())
				plugin.addAutoBuildNature(getProject());
			else
				plugin.removeAutoBuildNature(getProject());
		} catch (CoreException e) {
		}
		return true;
	}

}
