/*
 * Created on 29.06.2005
 *
 */
package org.eclipse.contribution.junit;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author Andreas
 *
 */
public class TestedMethod {
	
	private String klass;
	private String method;
	private List args;
	public ArrayList linenumbers;

	
	/**
	 * 
	 */
	public TestedMethod() {
		this.linenumbers = new ArrayList();
	}
	
	public TestedMethod(String klass, String method, List args) {
		this();
		this.klass = klass;
		this.method = method;
		this.args = args;
	}
	/**
	 * @return Returns the klass name of the tested method.
	 */
	public String getKlass() {
		return klass;
	}
	/**
	 * @return Returns the tested method name.
	 */
	public String getMethod() {
		return method;
	}
	
	public List getArgs(){
		return args;
	}
	
	public String [] getArgsAsString(){
		
		String [] temp = new String[args.size()];
		for (int i=0; i<args.size(); i++){
			temp[i] = (String) args.get(i);
		}
		return temp;
	}
	/**
	 * @param x The linenumber which will be appended.
	 */
	public void addLineNumber(int x) {
		linenumbers.add(new Integer(x));
	}
	
	public String toString(){
		StringBuffer testmethod = new StringBuffer();
		Integer i;
		testmethod.append("\tTESTED CLASS: "+this.getKlass()+"\n");
		testmethod.append("\tTESTED METHOD: "+this.getMethod()+" "+this.args.toString()+"\n");
		testmethod.append("\tTESTED LINES: "+"\n");
		Iterator iter = linenumbers.iterator();
		while (iter.hasNext()){
			i = (Integer) iter.next();
			testmethod.append("\t\t"+i.toString()+"\n");
		}
		return testmethod.toString();
	}
}
