package org.eclipse.contribution.junit;

import org.eclipse.core.resources.IMarker;
import org.eclipse.jdt.core.search.SearchEngine;
import org.eclipse.ui.IMarkerResolution;
import org.eclipse.ui.IMarkerResolutionGenerator;

public class MarkerResolutionGenerator implements IMarkerResolutionGenerator {
	
	public MarkerResolutionGenerator(){
	}

	public IMarkerResolution[] getResolutions(final IMarker marker) {
		IMarkerResolution resolution = new IMarkerResolution(){

			public String getLabel() {
				String markerhint;
				String message;
				markerhint = "CLASS: ";
				markerhint = markerhint.concat(marker.getAttribute("org.eclipse.contribution.junit.testclass", "test Class"));
				markerhint = markerhint.concat(" -- METHOD: ");
				markerhint = markerhint.concat(marker.getAttribute("org.eclipse.contribution.junit.testmethod", "test Method"));
				
				message = marker.getAttribute(IMarker.MESSAGE, "null");
				if (!message.equalsIgnoreCase("test ok!"))
					markerhint = markerhint.concat(" -- FAILED!");
				return markerhint;
			}

			public void run(IMarker marker){
			    String testmethod;
			    String testklass;
			    ClassSearcher cs = new ClassSearcher();
			    testmethod = marker.getAttribute("org.eclipse.contribution.junit.testmethod", "test Method");
			    testklass = marker.getAttribute("org.eclipse.contribution.junit.testclass", "test Class");
			    cs.findMethodDeclaration(SearchEngine.createWorkspaceScope(), testmethod, testklass);
			}
		};
		return new IMarkerResolution[] {resolution};
	}
}
